#!/bin/sh

actComp="/bundle/sc"
if [ -f /usr/bin/utils.sh ]; then
    source /usr/bin/utils.sh
else
    apiOK() { :; }
    apiNA() { :; }
    apiActive() { :; }
    apiActiveEcho() { :; }
    apiProgress() { :; }
    apiError() { :; }
fi

apiActive $actComp "Loading SC firmware."
echo "STATUS: Updating Storage Controller firmware."

export CURRENT_BUNDLE_VERSION=0
export TARGETED_BUNDLE_VERSION=0

flaName=$(ls components/*.fla);  # match any single sc firmware file

if [ -f "$flaName" ]; then

    fullFlaName=$(readlink -f $flaName)

    TARGETED_BUNDLE_VERSION=$(inicntrl /mnt/ramdisk/system/version.txt system_bundle version)
    CURRENT_BUNDLE_VERSION=$(inicntrl /cfg/version.txt system_bundle version)
    echo "Controller current bundle: $CURRENT_BUNDLE_VERSION,loading bundle $TARGETED_BUNDLE_VERSION"

    apiActive $actComp "Sending code to SC."
    echo "Instructing SC to shut down and NOT reboot"
    ../capi.app --loadscNoReboot $fullFlaName --component $actComp
    clireturn=$?

    rm -f $fullFlaName
    if [ "$clireturn" -eq "0" ]; then
        apiOK $actComp
        exit $LOAD_STATUS_SUCCESS
    else
        apiError $actComp 1100 "SC code load failed."
        exit $LOAD_STATUS_FAILED 
    fi
else
    apiNA $actComp
    echo "No SC firmware to update."
    exit $LOAD_STATUS_NOT_ATTEMPTED
fi
